Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/lib_fortran.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/lib_fortran.F90	(revision 3759)
+++ branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/lib_fortran.F90	(revision 3764)
@@ -8,7 +8,7 @@
 
    !!----------------------------------------------------------------------
-   !!   glob_sum    : generic interface for global masked summation over 
+   !!   glob_sum    : generic interface for global masked summation over
    !!                 the interior domain for 1 or 2 2D or 3D arrays
-   !!                 it works only for T points   
+   !!                 it works only for T points
    !!   SIGN        : generic interface for SIGN to overwrite f95 behaviour
    !!                 of intrinsinc sign function
@@ -29,12 +29,13 @@
 
    INTERFACE glob_sum
-      MODULE PROCEDURE glob_sum_2d, glob_sum_3d,glob_sum_2d_a, glob_sum_3d_a 
+      MODULE PROCEDURE glob_sum_1d, glob_sum_2d, glob_sum_3d, &
+         &             glob_sum_2d_a, glob_sum_3d_a
    END INTERFACE
 
-#if defined key_nosignedzero   
+#if defined key_nosignedzero
    INTERFACE SIGN
       MODULE PROCEDURE SIGN_SCALAR, SIGN_ARRAY_1D, SIGN_ARRAY_2D, SIGN_ARRAY_3D,   &
-         &             SIGN_ARRAY_1D_A, SIGN_ARRAY_2D_A, SIGN_ARRAY_3D_A,          & 
-         &             SIGN_ARRAY_1D_B, SIGN_ARRAY_2D_B, SIGN_ARRAY_3D_B 
+         &             SIGN_ARRAY_1D_A, SIGN_ARRAY_2D_A, SIGN_ARRAY_3D_A,          &
+         &             SIGN_ARRAY_1D_B, SIGN_ARRAY_2D_B, SIGN_ARRAY_3D_B
    END INTERFACE
 #endif
@@ -42,12 +43,27 @@
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
-   !! $Id$ 
+   !! $Id$
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-CONTAINS 
+CONTAINS
 
 #if ! defined key_mpp_rep
-
-   FUNCTION glob_sum_2d( ptab ) 
+   FUNCTION glob_sum_1d( ptab, kdim )
+      !!-----------------------------------------------------------------------
+      !!                  ***  FUNCTION  glob_sum_1D  ***
+      !!
+      !! ** Purpose : perform a masked sum on the inner global domain of a 1D array
+      !!-----------------------------------------------------------------------
+      INTEGER :: kdim
+      REAL(wp), INTENT(in), DIMENSION(kdim) ::   ptab        ! input 1D array
+      REAL(wp)                              ::   glob_sum_1d ! global sum
+      !!-----------------------------------------------------------------------
+      !
+      glob_sum_1d = SUM( ptab(:) )
+      IF( lk_mpp )   CALL mpp_sum( glob_sum_1d )
+      !
+   END FUNCTION glob_sum_1d
+
+   FUNCTION glob_sum_2d( ptab )
       !!-----------------------------------------------------------------------
       !!                  ***  FUNCTION  glob_sum_2D  ***
@@ -63,7 +79,7 @@
       !
    END FUNCTION glob_sum_2d
-   
-   
-   FUNCTION glob_sum_3d( ptab ) 
+
+
+   FUNCTION glob_sum_3d( ptab )
       !!-----------------------------------------------------------------------
       !!                  ***  FUNCTION  glob_sum_3D  ***
@@ -86,5 +102,5 @@
 
 
-   FUNCTION glob_sum_2d_a( ptab1, ptab2 ) 
+   FUNCTION glob_sum_2d_a( ptab1, ptab2 )
       !!-----------------------------------------------------------------------
       !!                  ***  FUNCTION  glob_sum_2D _a ***
@@ -95,5 +111,5 @@
       REAL(wp)            , DIMENSION(2)   ::   glob_sum_2d_a   ! global masked sum
       !!-----------------------------------------------------------------------
-      !             
+      !
       glob_sum_2d_a(1) = SUM( ptab1(:,:)*tmask_i(:,:) )
       glob_sum_2d_a(2) = SUM( ptab2(:,:)*tmask_i(:,:) )
@@ -101,7 +117,7 @@
       !
    END FUNCTION glob_sum_2d_a
- 
- 
-   FUNCTION glob_sum_3d_a( ptab1, ptab2 ) 
+
+
+   FUNCTION glob_sum_3d_a( ptab1, ptab2 )
       !!-----------------------------------------------------------------------
       !!                  ***  FUNCTION  glob_sum_3D_a ***
@@ -124,10 +140,36 @@
    END FUNCTION glob_sum_3d_a
 
-#else  
+#else
    !!----------------------------------------------------------------------
    !!   'key_mpp_rep'                                   MPP reproducibility
    !!----------------------------------------------------------------------
-   
-   FUNCTION glob_sum_2d( ptab ) 
+
+   FUNCTION glob_sum_1d( ptab, kdim )
+      !!----------------------------------------------------------------------
+      !!                  ***  FUNCTION  glob_sum_1d ***
+      !!
+      !! ** Purpose : perform a sum in calling DDPDD routine
+      !!----------------------------------------------------------------------
+      INTEGER , INTENT(in) :: kdim
+      REAL(wp), INTENT(in), DIMENSION(kdim) ::   ptab
+      REAL(wp)                              ::   glob_sum_1d   ! global sum
+      !!
+      COMPLEX(wp)::   ctmp
+      REAL(wp)   ::   ztmp
+      INTEGER    ::   ji   ! dummy loop indices
+      !!-----------------------------------------------------------------------
+      !
+      ztmp = 0.e0
+      ctmp = CMPLX( 0.e0, 0.e0, wp )
+      DO ji = 1, kdim
+         ztmp =  ptab(ji)
+         CALL DDPDD( CMPLX( ztmp, 0.e0, wp ), ctmp )
+         END DO
+      IF( lk_mpp )   CALL mpp_sum( ctmp )   ! sum over the global domain
+      glob_sum_1d = REAL(ctmp,wp)
+      !
+   END FUNCTION glob_sum_1d
+
+   FUNCTION glob_sum_2d( ptab )
       !!----------------------------------------------------------------------
       !!                  ***  FUNCTION  glob_sum_2d ***
@@ -154,8 +196,8 @@
       glob_sum_2d = REAL(ctmp,wp)
       !
-   END FUNCTION glob_sum_2d   
-
-
-   FUNCTION glob_sum_3d( ptab ) 
+   END FUNCTION glob_sum_2d
+
+
+   FUNCTION glob_sum_3d( ptab )
       !!----------------------------------------------------------------------
       !!                  ***  FUNCTION  glob_sum_3d ***
@@ -179,13 +221,13 @@
             CALL DDPDD( CMPLX( ztmp, 0.e0, wp ), ctmp )
             END DO
-         END DO    
+         END DO
       END DO
       IF( lk_mpp )   CALL mpp_sum( ctmp )   ! sum over the global domain
       glob_sum_3d = REAL(ctmp,wp)
       !
-   END FUNCTION glob_sum_3d   
-
-
-   FUNCTION glob_sum_2d_a( ptab1, ptab2 ) 
+   END FUNCTION glob_sum_3d
+
+
+   FUNCTION glob_sum_2d_a( ptab1, ptab2 )
       !!----------------------------------------------------------------------
       !!                  ***  FUNCTION  glob_sum_2d_a ***
@@ -214,8 +256,8 @@
       glob_sum_2d_a = REAL(ctmp,wp)
       !
-   END FUNCTION glob_sum_2d_a   
-
-
-   FUNCTION glob_sum_3d_a( ptab1, ptab2 ) 
+   END FUNCTION glob_sum_2d_a
+
+
+   FUNCTION glob_sum_3d_a( ptab1, ptab2 )
       !!----------------------------------------------------------------------
       !!                  ***  FUNCTION  glob_sum_3d_a ***
@@ -241,10 +283,10 @@
             CALL DDPDD( CMPLX( ztmp, 0.e0, wp ), ctmp )
             END DO
-         END DO    
+         END DO
       END DO
       IF( lk_mpp )   CALL mpp_sum( ctmp )   ! sum over the global domain
       glob_sum_3d_a = REAL(ctmp,wp)
       !
-   END FUNCTION glob_sum_3d_a   
+   END FUNCTION glob_sum_3d_a
 
 #endif
@@ -253,17 +295,17 @@
       !!----------------------------------------------------------------------
       !!               ***  ROUTINE DDPDD ***
-      !!          
+      !!
       !! ** Purpose : Add a scalar element to a sum
-      !!             
-      !!
-      !! ** Method  : The code uses the compensated summation with doublet 
+      !!
+      !!
+      !! ** Method  : The code uses the compensated summation with doublet
       !!              (sum,error) emulated useing complex numbers. ydda is the
-      !!               scalar to add to the summ yddb 
-      !! 
-      !! ** Action  : This does only work for MPI. 
+      !!               scalar to add to the summ yddb
+      !!
+      !! ** Action  : This does only work for MPI.
       !!
       !! References : Using Acurate Arithmetics to Improve Numerical
       !!              Reproducibility and Sability in Parallel Applications
-      !!              Yun HE and Chris H. Q. DING, Journal of Supercomputing 18, 259-277, 2001 
+      !!              Yun HE and Chris H. Q. DING, Journal of Supercomputing 18, 259-277, 2001
       !!----------------------------------------------------------------------
       COMPLEX(wp), INTENT(in   ) ::   ydda
@@ -288,5 +330,5 @@
    !!   'key_nosignedzero'                                         F90 SIGN
    !!----------------------------------------------------------------------
-   
+
    FUNCTION SIGN_SCALAR( pa, pb )
       !!-----------------------------------------------------------------------
@@ -304,5 +346,5 @@
 
 
-   FUNCTION SIGN_ARRAY_1D( pa, pb ) 
+   FUNCTION SIGN_ARRAY_1D( pa, pb )
       !!-----------------------------------------------------------------------
       !!                  ***  FUNCTION SIGN_ARRAY_1D  ***
@@ -319,5 +361,5 @@
 
 
-   FUNCTION SIGN_ARRAY_2D(pa,pb) 
+   FUNCTION SIGN_ARRAY_2D(pa,pb)
       !!-----------------------------------------------------------------------
       !!                  ***  FUNCTION SIGN_ARRAY_2D  ***
@@ -333,5 +375,5 @@
    END FUNCTION SIGN_ARRAY_2D
 
-   FUNCTION SIGN_ARRAY_3D(pa,pb) 
+   FUNCTION SIGN_ARRAY_3D(pa,pb)
       !!-----------------------------------------------------------------------
       !!                  ***  FUNCTION SIGN_ARRAY_3D  ***
@@ -348,5 +390,5 @@
 
 
-   FUNCTION SIGN_ARRAY_1D_A(pa,pb) 
+   FUNCTION SIGN_ARRAY_1D_A(pa,pb)
       !!-----------------------------------------------------------------------
       !!                  ***  FUNCTION SIGN_ARRAY_1D_A  ***
@@ -363,5 +405,5 @@
 
 
-   FUNCTION SIGN_ARRAY_2D_A(pa,pb) 
+   FUNCTION SIGN_ARRAY_2D_A(pa,pb)
       !!-----------------------------------------------------------------------
       !!                  ***  FUNCTION SIGN_ARRAY_2D_A  ***
@@ -378,5 +420,5 @@
 
 
-   FUNCTION SIGN_ARRAY_3D_A(pa,pb) 
+   FUNCTION SIGN_ARRAY_3D_A(pa,pb)
       !!-----------------------------------------------------------------------
       !!                  ***  FUNCTION SIGN_ARRAY_3D_A  ***
@@ -393,5 +435,5 @@
 
 
-   FUNCTION SIGN_ARRAY_1D_B(pa,pb) 
+   FUNCTION SIGN_ARRAY_1D_B(pa,pb)
       !!-----------------------------------------------------------------------
       !!                  ***  FUNCTION SIGN_ARRAY_1D_B  ***
@@ -408,5 +450,5 @@
 
 
-   FUNCTION SIGN_ARRAY_2D_B(pa,pb) 
+   FUNCTION SIGN_ARRAY_2D_B(pa,pb)
       !!-----------------------------------------------------------------------
       !!                  ***  FUNCTION SIGN_ARRAY_2D_B  ***
@@ -423,5 +465,5 @@
 
 
-   FUNCTION SIGN_ARRAY_3D_B(pa,pb) 
+   FUNCTION SIGN_ARRAY_3D_B(pa,pb)
       !!-----------------------------------------------------------------------
       !!                  ***  FUNCTION SIGN_ARRAY_3D_B  ***
Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 3759)
+++ branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 3764)
@@ -6,13 +6,13 @@
    !! History :  OPA  ! 1990-10  (C. Levy, G. Madec)  Original code
    !!            7.0  ! 1991-11  (M. Imbard, C. Levy, G. Madec)
-   !!            7.1  ! 1993-03  (M. Imbard, C. Levy, G. Madec, O. Marti, M. Guyon, A. Lazar, 
-   !!                             P. Delecluse, C. Perigaud, G. Caniaux, B. Colot, C. Maes) release 7.1 
+   !!            7.1  ! 1993-03  (M. Imbard, C. Levy, G. Madec, O. Marti, M. Guyon, A. Lazar,
+   !!                             P. Delecluse, C. Perigaud, G. Caniaux, B. Colot, C. Maes) release 7.1
    !!             -   ! 1992-06  (L.Terray)  coupling implementation
-   !!             -   ! 1993-11  (M.A. Filiberti) IGLOO sea-ice 
-   !!            8.0  ! 1996-03  (M. Imbard, C. Levy, G. Madec, O. Marti, M. Guyon, A. Lazar, 
+   !!             -   ! 1993-11  (M.A. Filiberti) IGLOO sea-ice
+   !!            8.0  ! 1996-03  (M. Imbard, C. Levy, G. Madec, O. Marti, M. Guyon, A. Lazar,
    !!                             P. Delecluse, L.Terray, M.A. Filiberti, J. Vialar, A.M. Treguier, M. Levy) release 8.0
    !!            8.1  ! 1997-06  (M. Imbard, G. Madec)
-   !!            8.2  ! 1999-11  (M. Imbard, H. Goosse)  LIM sea-ice model 
-   !!                 ! 1999-12  (V. Thierry, A-M. Treguier, M. Imbard, M-A. Foujols)  OPEN-MP 
+   !!            8.2  ! 1999-11  (M. Imbard, H. Goosse)  LIM sea-ice model
+   !!                 ! 1999-12  (V. Thierry, A-M. Treguier, M. Imbard, M-A. Foujols)  OPEN-MP
    !!                 ! 2000-07  (J-M Molines, M. Imbard)  Open Boundary Conditions  (CLIPPER)
    !!   NEMO     1.0  ! 2002-08  (G. Madec)  F90: Free form and modules
@@ -25,5 +25,5 @@
    !!             -   ! 2007-07  (J. Chanut, A. Sellar) Unstructured open boundaries (BDY)
    !!            3.2  ! 2009-08  (S. Masson)  open/write in the listing file in mpp
-   !!            3.3  ! 2010-05  (K. Mogensen, A. Weaver, M. Martin, D. Lea) Assimilation interface 
+   !!            3.3  ! 2010-05  (K. Mogensen, A. Weaver, M. Martin, D. Lea) Assimilation interface
    !!             -   ! 2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase
    !!            3.3.1! 2011-01  (A. R. Porter, STFC Daresbury) dynamical allocation
@@ -34,5 +34,5 @@
    !!   nemo_gcm       : solve ocean dynamics, tracer, biogeochemistry and/or sea-ice
    !!   nemo_init      : initialization of the NEMO system
-   !!   nemo_ctl       : initialisation of the contol print 
+   !!   nemo_ctl       : initialisation of the contol print
    !!   nemo_closefile : close remaining open files
    !!   nemo_alloc     : dynamical allocation
@@ -64,4 +64,5 @@
    USE diadct          ! sections transports           (dia_dct_init routine)
    USE diaobs          ! Observation diagnostics       (dia_obs_init routine)
+   USE lib_fortran     ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)
    USE step            ! NEMO time-stepping                 (stp     routine)
    USE icbini          ! handle bergs, initialisation
@@ -83,5 +84,4 @@
    USE sbctide, ONLY: lk_tide
 
-
    IMPLICIT NONE
    PRIVATE
@@ -89,4 +89,5 @@
    PUBLIC   nemo_gcm    ! called by model.F90
    PUBLIC   nemo_init   ! needed by AGRIF
+   PUBLIC   nemo_alloc  ! needed by TAM
 
    CHARACTER(lc) ::   cform_aaa="( /, 'AAAAAAAA', / ) "     ! flag for output listing
@@ -103,5 +104,5 @@
       !!                     ***  ROUTINE nemo_gcm  ***
       !!
-      !! ** Purpose :   NEMO solves the primitive equations on an orthogonal 
+      !! ** Purpose :   NEMO solves the primitive equations on an orthogonal
       !!              curvilinear mesh on the sphere.
       !!
@@ -151,15 +152,11 @@
           IF( lk_asminc ) THEN
              IF( ln_bkgwri ) CALL asm_bkg_wri( nit000 - 1 )    ! Output background fields
-             IF( ln_trjwri ) CALL asm_trj_wri( nit000 - 1 )    ! Output trajectory fields
              IF( ln_asmdin ) THEN                        ! Direct initialization
                 IF( ln_trainc ) CALL tra_asm_inc( nit000 - 1 )    ! Tracers
-                IF( ln_dyninc ) THEN 
-                   CALL dyn_asm_inc( nit000 - 1 )    ! Dynamics
-                   IF ( ln_asmdin ) CALL ssh_wzv ( nit000 - 1 )      ! update vertical velocity 
-                ENDIF
+                IF( ln_dyninc ) CALL dyn_asm_inc( nit000 - 1 )    ! Dynamics
                 IF( ln_sshinc ) CALL ssh_asm_inc( nit000 - 1 )    ! SSH
              ENDIF
           ENDIF
-        
+
          DO WHILE ( istp <= nitend .AND. nstop == 0 )
 #if defined key_agrif
@@ -176,5 +173,5 @@
       !
       IF( ln_icebergs )   CALL icb_end( nitend )
-       
+
       !                            !------------------------!
       !                            !==  finalize the run  ==!
@@ -184,5 +181,5 @@
       IF( nstop /= 0 .AND. lwp ) THEN   ! error print
          WRITE(numout,cform_err)
-         WRITE(numout,*) nstop, ' error have been found' 
+         WRITE(numout,*) nstop, ' error have been found'
       ENDIF
       !
@@ -261,5 +258,5 @@
       lwp = (narea == 1) .OR. ln_ctl                        ! control of all listing output print
 
-      ! If dimensions of processor grid weren't specified in the namelist file 
+      ! If dimensions of processor grid weren't specified in the namelist file
       ! then we calculate them here now that we have our communicator size
       IF( (jpni < 1) .OR. (jpnj < 1) )THEN
@@ -302,5 +299,5 @@
          WRITE(numout,*)
          WRITE(numout,*)
-         DO ji = 1, SIZE(cltxt) 
+         DO ji = 1, SIZE(cltxt)
             IF( TRIM(cltxt(ji)) /= '' )   WRITE(numout,*) cltxt(ji)      ! control print of mynode
          END DO
@@ -309,5 +306,5 @@
       ENDIF
 
-      ! Now we know the dimensions of the grid and numout has been set we can 
+      ! Now we know the dimensions of the grid and numout has been set we can
       ! allocate arrays
       CALL nemo_alloc()
@@ -336,5 +333,5 @@
       IF( ln_ctl        )   CALL prt_ctl_init   ! Print control
 
-      IF( lk_obc        )   CALL     obc_init   ! Open boundaries 
+      IF( lk_obc        )   CALL     obc_init   ! Open boundaries
 
                             CALL  istate_init   ! ocean initial state (Dynamics and tracers)
@@ -349,5 +346,5 @@
 
       !                                     ! Ocean physics
-                            CALL     sbc_init   ! Forcings : surface module 
+                            CALL     sbc_init   ! Forcings : surface module
       !                                         ! Vertical physics
                             CALL     zdf_init      ! namelist read
@@ -358,5 +355,5 @@
       IF( lk_zdfkpp     )   CALL zdf_kpp_init      ! KPP closure scheme
       IF( lk_zdftmx     )   CALL zdf_tmx_init      ! tidal vertical mixing
-      IF( lk_zdfddm .AND. .NOT. lk_zdfkpp )   & 
+      IF( lk_zdfddm .AND. .NOT. lk_zdfkpp )   &
          &                  CALL zdf_ddm_init      ! double diffusive mixing
       !                                         ! Lateral physics
@@ -381,5 +378,5 @@
                             CALL dyn_zdf_init   ! vertical diffusion
                             CALL dyn_spg_init   ! surface pressure gradient
-                            
+
       !                                     ! Misc. options
       IF( nn_cla == 1   )   CALL cla_init       ! Cross Land Advection
@@ -401,5 +398,5 @@
                             CALL dia_obs_init            ! Initialize observational data
                             CALL dia_obs( nit000 - 1 )   ! Observation operator for restart
-      ENDIF      
+      ENDIF
       !                                     ! Assimilation increments
       IF( lk_asminc     )   CALL asm_inc_init   ! Initialize assimilation increments
@@ -413,5 +410,5 @@
       !!                     ***  ROUTINE nemo_ctl  ***
       !!
-      !! ** Purpose :   control print setting 
+      !! ** Purpose :   control print setting
       !!
       !! ** Method  : - print namctl information and check some consistencies
@@ -460,5 +457,5 @@
          !                              ! indices used for the SUM control
          IF( nictls+nictle+njctls+njctle == 0 )   THEN    ! print control done over the default area
-            lsp_area = .FALSE.                        
+            lsp_area = .FALSE.
          ELSE                                             ! print control done over a specific  area
             lsp_area = .TRUE.
@@ -482,5 +479,5 @@
       ENDIF
       !
-      IF( nbench == 1 ) THEN              ! Benchmark 
+      IF( nbench == 1 ) THEN              ! Benchmark
          SELECT CASE ( cp_cfg )
          CASE ( 'gyre' )   ;   CALL ctl_warn( ' The Benchmark is activated ' )
@@ -493,4 +490,8 @@
          &                                               'with the IOM Input/Output manager. '         ,   &
          &                                               'Compile with key_iomput enabled' )
+      !
+      IF( 1_wp /= SIGN(1._wp,-0._wp)  )   CALL ctl_stop( 'nemo_ctl: The intrinsec SIGN function follows ',  &
+         &                                               'f2003 standard. '                              ,  &
+         &                                               'Compile with key_nosignedzero enabled' )
       !
    END SUBROUTINE nemo_ctl
@@ -544,5 +545,5 @@
       !!----------------------------------------------------------------------
       !
-      ierr =        oce_alloc       ()          ! ocean 
+      ierr =        oce_alloc       ()          ! ocean
       ierr = ierr + dia_wri_alloc   ()
       ierr = ierr + dom_oce_alloc   ()          ! ocean domain
@@ -568,5 +569,5 @@
       !!                 ***  ROUTINE nemo_partition  ***
       !!
-      !! ** Purpose :   
+      !! ** Purpose :
       !!
       !! ** Method  :
@@ -616,5 +617,5 @@
       !!
       !! ** Purpose :   return the prime factors of n.
-      !!                knfax factors are returned in array kfax which is of 
+      !!                knfax factors are returned in array kfax which is of
       !!                maximum dimension kmaxfax.
       !! ** Method  :
@@ -684,8 +685,8 @@
       !!=====================================================================
       !!----------------------------------------------------------------------
-      !! 
+      !!
       !! ** Purpose :   Initialization of the northern neighbours lists.
       !!----------------------------------------------------------------------
-      !!    1.0  ! 2011-10  (A. C. Coward, NOCS & J. Donners, PRACE) 
+      !!    1.0  ! 2011-10  (A. C. Coward, NOCS & J. Donners, PRACE)
       !!----------------------------------------------------------------------
 
@@ -769,5 +770,5 @@
       jtyp = 5
       lrankset = .FALSE.
-      znnbrs = narea 
+      znnbrs = narea
       CALL lbc_lnk( znnbrs, 'J', 1. ) ! first ice U-V point
 
@@ -782,5 +783,5 @@
       ENDIF
 
-      znnbrs = narea 
+      znnbrs = narea
       CALL lbc_lnk( znnbrs, 'K', 1. ) ! second ice U-V point
 
@@ -805,5 +806,5 @@
          END DO
          !
-         ! For northern row areas, set l_north_nogather so that all subsequent exchanges 
+         ! For northern row areas, set l_north_nogather so that all subsequent exchanges
          ! can use peer to peer communications at the north fold
          !
Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/step.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 3759)
+++ branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 3764)
@@ -29,5 +29,5 @@
    !!   stp             : OPA system time-stepping
    !!----------------------------------------------------------------------
-   USE step_oce         ! time stepping definition modules 
+   USE step_oce         ! time stepping definition modules
 #if defined key_top
    USE trcstp           ! passive tracer time-stepping      (trc_stp routine)
@@ -62,13 +62,13 @@
       !!----------------------------------------------------------------------
       !!                     ***  ROUTINE stp  ***
-      !!                      
+      !!
       !! ** Purpose : - Time stepping of OPA (momentum and active tracer eqs.)
       !!              - Time stepping of LIM (dynamic and thermodynamic eqs.)
       !!              - Tme stepping  of TRC (passive tracer eqs.)
-      !! 
-      !! ** Method  : -1- Update forcings and data  
-      !!              -2- Update ocean physics 
-      !!              -3- Compute the t and s trends 
-      !!              -4- Update t and s 
+      !!
+      !! ** Method  : -1- Update forcings and data
+      !!              -2- Update ocean physics
+      !!              -3- Compute the t and s trends
+      !!              -4- Update t and s
       !!              -5- Compute the momentum trends
       !!              -6- Update the horizontal velocity
@@ -86,6 +86,6 @@
 # if defined key_iomput
       IF( Agrif_Nbstepint() == 0 )   CALL iom_swap
-# endif   
-#endif   
+# endif
+#endif
                              indic = 0                ! reset to no error condition
       IF( kstp /= nit000 )   CALL day( kstp )         ! Calendar (day was already called at nit000 in day_init)
@@ -113,7 +113,7 @@
                          CALL bn2( tsn, rn2  )        ! now    Brunt-Vaisala frequency
       !
-      !  VERTICAL PHYSICS   
+      !  VERTICAL PHYSICS
                          CALL zdf_bfr( kstp )         ! bottom friction
-                         
+
       !                                               ! Vertical eddy viscosity and diffusivity coefficients
       IF( lk_zdfric  )   CALL zdf_ric( kstp )            ! Richardson number dependent Kz
@@ -135,5 +135,5 @@
       IF( lk_zdfddm .AND. .NOT. lk_zdfkpp )   &
          &               CALL zdf_ddm( kstp )         ! double diffusive mixing
-         
+
                          CALL zdf_mxl( kstp )         ! mixed layer depth
 
@@ -142,5 +142,5 @@
       IF( lrst_oce .AND. lk_zdfgls )   CALL gls_rst( kstp, 'WRITE' )
       !
-      !  LATERAL  PHYSICS 
+      !  LATERAL  PHYSICS
       !
       IF( lk_ldfslp ) THEN                            ! slope of lateral mixing
@@ -211,5 +211,5 @@
          IF( ln_zps      )   CALL zps_hde( kstp, jpts, tsa, gtsu, gtsv,  &    ! zps: time filtered hor. derivative
             &                                          rhd, gru , grv  )      ! of t, s, rd at the last ocean level
-         
+
       ELSE                                                  ! centered hpg  (eos then time stepping)
                              CALL eos    ( tsn, rhd, rhop )      ! now in situ density for hpg computation
@@ -218,5 +218,5 @@
          IF( ln_zdfnpc   )   CALL tra_npc( kstp )                ! update after fields by non-penetrative convection
                              CALL tra_nxt( kstp )                ! tracer fields at next time step
-      ENDIF 
+      ENDIF
 
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
@@ -228,4 +228,5 @@
       IF(  ln_asmiau .AND. &
          & ln_dyninc       )   CALL dyn_asm_inc( kstp )     ! apply dynamics assimilation increment
+      IF( ln_bkgwri )          CALL asm_bkg_wri( kstp )     ! output background fields
       IF( ln_neptsimp )        CALL dyn_nept_cor( kstp )    ! subtract Neptune velocities (simplified)
       IF( lk_bdy           )   CALL bdy_dyn3d_dmp(kstp )    ! bdy damping trends
@@ -238,5 +239,5 @@
 #endif
                                CALL dyn_hpg( kstp )         ! horizontal gradient of Hydrostatic pressure
-                               CALL dyn_bfr( kstp )         ! bottom friction   
+                               CALL dyn_bfr( kstp )         ! bottom friction
                                CALL dyn_zdf( kstp )         ! vertical diffusion
                                CALL dyn_spg( kstp, indic )  ! surface pressure gradient
@@ -263,8 +264,8 @@
       ! Trends                              (ua, va, tsa used as workspace)
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-      IF( nstop == 0 ) THEN                         
-         IF( lk_trddyn     )   CALL trd_dwr( kstp )         ! trends: dynamics 
+      IF( nstop == 0 ) THEN
+         IF( lk_trddyn     )   CALL trd_dwr( kstp )         ! trends: dynamics
          IF( lk_trdtra     )   CALL trd_twr( kstp )         ! trends: active tracers
-         IF( lk_trdmld     )   CALL trd_mld( kstp )         ! trends: Mixed-layer 
+         IF( lk_trdmld     )   CALL trd_mld( kstp )         ! trends: Mixed-layer
          IF( lk_trdvor     )   CALL trd_vor( kstp )         ! trends: vorticity budget
       ENDIF
Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/step_oce.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/step_oce.F90	(revision 3759)
+++ branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/step_oce.F90	(revision 3764)
@@ -7,5 +7,5 @@
    !!----------------------------------------------------------------------
    USE oce              ! ocean dynamics and tracers variables
-   USE dom_oce          ! ocean space and time domain variables 
+   USE dom_oce          ! ocean space and time domain variables
    USE zdf_oce          ! ocean vertical physics variables
    USE ldftra_oce       ! ocean tracer   - trends
@@ -84,5 +84,5 @@
    USE trdmld_rst       ! restart for mixed-layer trends
    USE trdmod_oce       ! ocean momentum/tracers trends
-   USE trdmod           ! momentum/tracers trends   
+   USE trdmod           ! momentum/tracers trends
    USE trdvor           ! vorticity budget                 (trd_vor routine)
    USE diaptr           ! poleward transports              (dia_ptr routine)
@@ -98,5 +98,5 @@
    USE asminc           ! assimilation increments      (tra_asm_inc routine)
    !                                                   (dyn_asm_inc routine)
-
+   USE asmbkg
    USE stpctl           ! time stepping control            (stp_ctl routine)
    USE prtctl           ! Print control                    (prt_ctl routine)
@@ -104,5 +104,5 @@
    USE diaobs           ! Observation operator
 
-   USE timing           ! Timing            
+   USE timing           ! Timing
 
 #if defined key_agrif
